Loading...
Searching...
No Matches
casacore::FITSTabular Class Referenceabstract
fits package (libcasa_fits) » FITS_module

More...

`#include <FITSTable.h>`

## Public Member Functions

virtual | ~FITSTabular ()
virtual Bool | isValid () const =0
| isValid() returns False if this object isn't a valid Tabular data structure.
virtual const TableRecord & | keywords () const =0
| Returns keywords which are associated with the underlying FITS files.
virtual const RecordDesc & | description () const =0
| Returns the description of the underlying FITS table.
virtual const Record & | units () const =0
| Returns any TUNITnnn associated with a column (the field names are the column names, each field value is the TUNITnnn value for that field).
virtual const Record & | displayFormats () const =0
| Returns any TDISPnnn associated with a column (the field names are the column names, each field value is the TDISPnnn value for that field).
virtual const Record & | nulls () const =0
| Returns any TNULLnnn associated with a column (the field names are the column names, each field value is the TNULLnnn value for that field).
virtual Bool | pastEnd () const =0
| Returns True if we have advanced past the end of data.
virtual void | next ()=0
| Advance the row if possible (guaranteed harmless if pastEnd() is True.
virtual Bool | reopen (const String &)
| Reopen the table, default behavior is to do nothing, return False.
virtual const String & | name () const =0
| return the name
virtual Bool | hasChanged () const
| Has the description changed since construction, default is False.
virtual void | resetChangedFlag ()
| reset the changed flag, default do nothing
virtual const Record & | currentRow () const =0
| Return the currentRow.

## Static Public Member Functions

static TableRecord | keywordsFromHDU (HeaderDataUnit &hdu, Bool allKeywords=False)
| Helper function for retrieving keywords from a native-FITS hdu.
static RecordDesc | descriptionFromHDU (BinaryTableExtension &hdu)
| Helper function for retrieving a description from a native-FITS hdu.
static Record | subStringShapeFromHDU (BinaryTableExtension &hdu)
| Help function for retrieving any shape information from String columns using the SubString convention.
static Record | unitsFromHDU (BinaryTableExtension &hdu)
| Helper function for retrieving the TUNITnnn from a native-FITS hdu.
static Record | displayFormatsFromHDU (BinaryTableExtension &hdu)
| Helper function for retrieving the TDISPnnn from a native-FITS hdu.
static Record | nullsFromHDU (BinaryTableExtension &hdu)
| Helper function for retrieving the TNULLnnn from a native-FITS hdu.
static TableDesc | tableDesc (const FITSTabular &fitstabular)
| Get a TableDesc appropriate to hold a FITSTabular the keywords, description, units, displayFormats, and nulls are all used.

## Detailed Description

Simplified interface to FITS tables with Casacore Look and Feel.

### Intended use:

Public interface

### Review Status

Date Reviewed:
  yyyy/mm/dd

### Prerequisite

- General knowledge of FITS binary and ASCII tables.

### Etymology

### Synopsis

FITSTablular is an obstract base class which is used for read-only access to tabular FITS-like data structures.

### Example

### Motivation

### To Do

- Eventually we'd like to be able to write the tables as well as read them.

Definition at line 77 of file FITSTable.h.

## Constructor & Destructor Documentation

## ~FITSTabular()

virtual casacore::FITSTabular::~FITSTabular | ( |  | ) |

virtual

## Member Function Documentation

## currentRow()

virtual const Record & casacore::FITSTabular::currentRow | ( |  | ) | const

pure virtual

Return the currentRow.

This is guaranteed to be valid so long as only member functions of this base class are called (so you can safely attach RecordFieldPtr objects to it. The result is undefined if pastEnd() is True.

Implemented in casacore::FITSMultiTable, casacore::FITSTable, and casacore::FITSTimedTable.

References casacore::Record().

## description()

virtual const RecordDesc & casacore::FITSTabular::description | ( |  | ) | const

pure virtual

Returns the description of the underlying FITS table.

Implemented in casacore::FITSMultiTable, casacore::FITSTable, and casacore::FITSTimedTable.

## descriptionFromHDU()

RecordDesc casacore::FITSTabular::descriptionFromHDU | ( | BinaryTableExtension & | hdu | ) |

static

Helper function for retrieving a description from a native-FITS hdu.

## displayFormats()

virtual const Record & casacore::FITSTabular::displayFormats | ( |  | ) | const

pure virtual

Returns any TDISPnnn associated with a column (the field names are the column names, each field value is the TDISPnnn value for that field).

Note that only those columns with a non-empty TDISPnnn have an entry in the displayFormats() Record.

Implemented in casacore::FITSMultiTable, casacore::FITSTable, and casacore::FITSTimedTable.

References casacore::Record().

## displayFormatsFromHDU()

Record casacore::FITSTabular::displayFormatsFromHDU | ( | BinaryTableExtension & | hdu | ) |

static

Helper function for retrieving the TDISPnnn from a native-FITS hdu.

References casacore::Record().

## hasChanged()

virtual Bool casacore::FITSTabular::hasChanged | ( |  | ) | const

inline virtual

Has the description changed since construction, default is False.

Reimplemented in casacore::FITSMultiTable, and casacore::FITSTimedTable.

Definition at line 121 of file FITSTable.h.

References casacore::False.

## isValid()

virtual Bool casacore::FITSTabular::isValid | ( |  | ) | const

pure virtual

isValid() returns False if this object isn't a valid Tabular data structure.

Implemented in casacore::FITSMultiTable, casacore::FITSTable, and casacore::FITSTimedTable.

## keywords()

virtual const TableRecord & casacore::FITSTabular::keywords | ( |  | ) | const

pure virtual

Returns keywords which are associated with the underlying FITS files.

Implemented in casacore::FITSMultiTable, casacore::FITSTable, and casacore::FITSTimedTable.

## keywordsFromHDU()

TableRecord casacore::FITSTabular::keywordsFromHDU | ( | HeaderDataUnit & | hdu,
|  | Bool | allKeywords = False )

static

Helper function for retrieving keywords from a native-FITS hdu.

If allKeywords is not True, some keywords will be excluded from the list. Currently the list of excluded keywords includes TTYPEnnn, TFORMnnn, and TUNITnnn

References casacore::False.

## name()

virtual const String & casacore::FITSTabular::name | ( |  | ) | const

pure virtual

return the name

Implemented in casacore::FITSMultiTable, casacore::FITSTable, and casacore::FITSTimedTable.

## next()

virtual void casacore::FITSTabular::next | ( |  | ) |

pure virtual

Advance the row if possible (guaranteed harmless if pastEnd() is True.

Implemented in casacore::FITSMultiTable, casacore::FITSTable, and casacore::FITSTimedTable.

## nulls()

virtual const Record & casacore::FITSTabular::nulls | ( |  | ) | const

pure virtual

Returns any TNULLnnn associated with a column (the field names are the column names, each field value is the TNULLnnn value for that field).

Note that only those columns with a specific entry for TNULLnnn and which have not been promoted to doubles due TSCAL and TZERO values will have an entry in the nulls() Record. The meaning of TNULL is only defined for integer and byte columns. When a column is promoted to a double because of scaling, any TNULL values will be assigned a value of NaN.

Implemented in casacore::FITSMultiTable, casacore::FITSTable, and casacore::FITSTimedTable.

References casacore::Record().

## nullsFromHDU()

Record casacore::FITSTabular::nullsFromHDU | ( | BinaryTableExtension & | hdu | ) |

static

Helper function for retrieving the TNULLnnn from a native-FITS hdu.

References casacore::Record().

## pastEnd()

virtual Bool casacore::FITSTabular::pastEnd | ( |  | ) | const

pure virtual

Returns True if we have advanced past the end of data.

Implemented in casacore::FITSMultiTable, casacore::FITSTable, and casacore::FITSTimedTable.

## reopen()

virtual Bool casacore::FITSTabular::reopen | ( | const String & |  | ) |

inline virtual

Reopen the table, default behavior is to do nothing, return False.

Reimplemented in casacore::FITSTable, and casacore::SDFITSTable.

Definition at line 115 of file FITSTable.h.

References casacore::False.

## resetChangedFlag()

virtual void casacore::FITSTabular::resetChangedFlag | ( |  | ) |

inline virtual

reset the changed flag, default do nothing

Reimplemented in casacore::FITSMultiTable, and casacore::FITSTimedTable.

Definition at line 123 of file FITSTable.h.

## subStringShapeFromHDU()

Record casacore::FITSTabular::subStringShapeFromHDU | ( | BinaryTableExtension & | hdu | ) |

static

Help function for retrieving any shape information from String columns using the SubString convention.

Information is returned in a Record having named fields = all String columns following those convention. Each of these fields is, in turn, a sub-record having these three fields: NCHAR, NELEM, DELIM.
If NELEM == -1 then there must have been a DELIM specified and this field is a variable shaped string array where each element has at most NCHAR and they are separated by DELIM (which is a String field here). Otherwise, DELIM is not used and there are NCHAR per element for each of NELEM in each cell for this column.

References casacore::Record().

## tableDesc()

TableDesc casacore::FITSTabular::tableDesc | ( | const FITSTabular & | fitstabular | ) |

static

Get a TableDesc appropriate to hold a FITSTabular the keywords, description, units, displayFormats, and nulls are all used.

## units()

virtual const Record & casacore::FITSTabular::units | ( |  | ) | const

pure virtual

Returns any TUNITnnn associated with a column (the field names are the column names, each field value is the TUNITnnn value for that field).

Note that only those columns with a non-empty TUNITnnn have an entry in the units() Record.

Implemented in casacore::FITSMultiTable, casacore::FITSTable, and casacore::FITSTimedTable.

References casacore::Record().

## unitsFromHDU()

Record casacore::FITSTabular::unitsFromHDU | ( | BinaryTableExtension & | hdu | ) |

static

Helper function for retrieving the TUNITnnn from a native-FITS hdu.

References casacore::Record().

The documentation for this class was generated from the following file:

- fits/FITS/FITSTable.h